unit ugeraden;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons,
  ExtCtrls, ComCtrls;

type

  { Tfgeraden }

  Tfgeraden = class(TForm)
    BitBtn1: TBitBtn;
    b_berechne: TButton;
    e_tb_a: TEdit;
    e_tb_b: TEdit;
    e_m1: TEdit;
    e_n1: TEdit;
    e_m2: TEdit;
    e_n2: TEdit;
    e_xs: TEdit;
    e_ys: TEdit;
    e_alphagrad: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    laussage: TLabel;
    lthema: TLabel;
    tb_a: TTrackBar;
    tb_b: TTrackBar;
    procedure b_berechneClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tb_aChange(Sender: TObject);
    procedure tb_bChange(Sender: TObject);
  private

  public


  end;

var
  fgeraden: Tfgeraden;
  a,b : SINGLE;

implementation

{$R *.lfm}

{ Tfgeraden }

procedure Tfgeraden.b_berechneClick(Sender: TObject);
VAR m1,n1,m2,n2,xs,ys,aBogen,aGrad : SINGLE;
    g1_x1,g1_y1,g1_x2,g1_y2,g2_x1,g2_y1,g2_x2,g2_y2 : SINGLE;

PROCEDURE Trans(x0,y0:SINGLE; VAR x,y:SINGLE);
BEGIN
 x := x0 + 100;
 y := -(y0 - 100);
END;

begin
 //Eingaben
 m1:= STRTOFLOAT(e_m1.text);
 n1:= STRTOFLOAT(e_n1.text);
 m2:= STRTOFLOAT(e_m2.text);
 n2:= STRTOFLOAT(e_n2.text);
 //Verarbeitung
 IF m1 <> m2 THEN BEGIN
                   xs:=(n2-n1)/(m1-m2); //bei gleichen m-Werten Div /0-Fehler
                   ys:=m1*xs+n1;
                   IF 1+m2*m1<>0 THEN aBogen:=ARCTAN(ABS((m2-m1)/(1+m2*m1)))  //Fehler bei 90°-Winkeln
                                 ELSE aBogen:=PI/2;
                   aGrad:=aBogen*180/PI;
                   e_xs.text:=FLOATTOSTRF(xs,ffnumber,18,2);
                   e_ys.text:=FLOATTOSTRF(ys,ffnumber,18,2);
                   e_alphagrad.text:=FLOATTOSTRF(aGrad,ffnumber,18,2);
                   laussage.caption:='Geraden schneiden sich.';
                  END
             ELSE IF n1 <> n2 THEN BEGIN
                                    e_xs.text:='-';
                                    e_ys.text:='-';
                                    e_alphagrad.text:='-';
                                    laussage.caption:='Geraden liegen parallel zueinander'
                                   END
                              ELSE BEGIN
                                    e_xs.text:='-';
                                    e_ys.text:='-';
                                    e_alphagrad.text:='-';
                                    laussage.caption:='Geraden sind identisch';
                                   END;


 //Ausgaben

 //Punkte berechnen
 //Init
 g1_x1:=0; g1_y1:=0; g1_x2:=0; g1_y2:=0;
 g2_x1:=0; g2_y1:=0; g2_x2:=0; g2_y2:=0;

 //Intervallgrenzen
   // a := -20; b := 20; sind global
 //Gerade1
   Trans(a,m1*a+n1,g1_x1,g1_y1);
   Trans(b,m1*b+n1,g1_x2,g1_y2);
 //Gerade2
   Trans(a,m2*a+n2,g2_x1,g2_y1);
   Trans(b,m2*b+n2,g2_x2,g2_y2);

 //Geraden zeichnen
 WITH Image1 DO
    BEGIN
     CANVAS.BRUSH.COLOR:=clWhite;
     CANVAS.RECTANGLE(0,0,Image1.Width,Image1.Height);
     CANVAS.PEN.COLOR:=clBlack;
     CANVAS.PEN.WIDTH:= 1;
     CANVAS.PEN.STYLE:=psSolid;
     //Achsen
     CANVAS.LINE(100,0,100,200);
     CANVAS.LINE(0,100,200,100);
     //Achsenpfeile
     CANVAS.LINE(100,0,105,10);
     CANVAS.LINE(100,0,95,10);
     CANVAS.LINE(200,100,190,95);
     CANVAS.LINE(200,100,190,105);

     //Geraden
     CANVAS.LINE(TRUNC(g1_x1),TRUNC(g1_y1),TRUNC(g1_x2),TRUNC(g1_y2));
     CANVAS.LINE(TRUNC(g2_x1),TRUNC(g2_y1),TRUNC(g2_x2),TRUNC(g2_y2));
    END;

end;

procedure Tfgeraden.FormCreate(Sender: TObject);
begin
  a:=tb_a.Position; b:=tb_b.Position;     //Grundeinstellungen des Intervalls [a,b] in den Trackbars
end;

procedure Tfgeraden.tb_aChange(Sender: TObject);
begin
  a:=tb_a.Position;
  e_tb_a.text := FLOATTOSTR(a);
end;

procedure Tfgeraden.tb_bChange(Sender: TObject);
begin
  b:=tb_b.Position;
  e_tb_b.text := FLOATTOSTR(b);
end;

end.

